//拓展Format函数以获取时间
Date.prototype.Format = function(fmt) { //author: meizz 
    var o = {
        "M+": this.getMonth() + 1, //月份 
        "d+": this.getDate(), //日 
        "h+": this.getHours(), //小时 
        "m+": this.getMinutes(), //分 
        "s+": this.getSeconds(), //秒 
        "S": this.getMilliseconds() //毫秒 
    };
    if (/(y+)/.test(fmt)) fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
    for (var k in o)
        if (new RegExp("(" + k + ")").test(fmt)) fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
    return fmt;
}

// 云函数入口文件
const cloud = require('wx-server-sdk')

cloud.init()
const db = cloud.database();

//修改商品信息
var rewriteProduct = async (event) => {
	//取出来
	var oldPInfo = await db.collection('sM_productInfo').doc(event.productId).get();
	//改信息
	if(event.isSall) {
		//卖出
		var stats = 2;
		oldPInfo.data.isSall = true;
	} else {
		//价格修改
		var stats = 1;
		if(event.newisFree) {
			oldPInfo.data.price = "免费";
			oldPInfo.data.isfree = true ;
		}else {
			oldPInfo.data.price =  event.newPrice;
			oldPInfo.data.isfree = false;
		}
	}
	delete oldPInfo.data._id;
	//放回去
	var res = await db.collection('sM_productInfo').doc(event.productId).set({
		data: oldPInfo.data
	}).then(res => {
		if(res.stats.updated === 0) {
			return {
				errCode: 201,
				errMsg: '重写商品信息失败(id错误)',
				id: event.productId
			}
		} else return {
			errCode: 200,
			errMsg: 'ok'
		};
	}).catch(err => {
		return {
			errCode: 202,
			errMsg: '重写商品信息失败',
			err: err,
		}
	})
	if(res.errCode !== 200) return res;
	else return {
		errCode: 200,
		errMsg:{
			productInfo: oldPInfo.data,
			stats: stats,
		}
	}
}

//给想要的人发通知
var sendMsg = async (event,productInfo,stats) => {
	var wantList = productInfo.wantUser;
	var length = wantList.length;
	for (var i = 0; i < length; i++) {
		await db.collection('sM_userInfo').doc(wantList[i]).update({
			data: {
				unreadMsg: db.command.push({
					stats: stats,
					productName: productInfo.title,
					productId: event.productId,
					time: (new Date(new Date().getTime() + 1000 * 60 * 60 * 8)).Format("yyyy-MM-dd hh:mm:ss"), //+8时差,
					isWant: true,
				})
			}
		})
	}
}

//删掉本人的issue
var deleteIssue = async (userId,productId) => {
	var userInfo = await db.collection('sM_userInfo').doc(userId).get();
	userInfo = userInfo.data;
	for(var i in userInfo.issue) {
		if(userInfo.issue[i].id = productId) userInfo.issue.splice(i, 1);
	}
	delete userInfo._id;
	var res = await db.collection('sM_userInfo').doc(userId).set({
		data: userInfo
	}).then(res => {
		if(res.stats.updated === 0) {
			return {
				errCode: 203,
				errMsg: '重写用户issue失败(id错误)',
				id: userId
			}
		} else return {
			errCode: 200,
			errMsg: 'ok'
		};
	}).catch(err => {
		return {
			errCode: 204,
			errMsg: '重写用户issue失败',
			err: err,
		}
	})
	return res;
}

// 云函数入口函数
exports.main = async (event, context) => {
	var rewRes = await rewriteProduct(event);
	if(rewRes.errCode !== 200) return rewRes;
	if(rewRes.errMsg.stats==2) {
		var delRes = await deleteIssue(event.userId,event.productId);
		if(delRes.errCode !==200) return delRes;
	}
	await sendMsg(event,rewRes.errMsg.productInfo,rewRes.errMsg.stats);
 	return rewRes;
}

/*
	api说明：
		功能：用户可以在发布完商品的时候修改商品信息，仅限于价格和是否售出。
		参数：
			productId:修改的产品id
			newPrice:新价格
			newisFree:是否免费
			isSall:是否已经卖出
			userId:用户id
		备注：isSall,userId 和 newPrice,newisFree 二选一传参就行
		作者：RainSun
		时间：2019/05/01
*/
/*
	错误报告：
	注：err表示catch函数返回的错误，msg就是问题描述

		正常：
			code:200
			msg:正常的返回值或者'ok'

		创建新商品失败(id错误)：
			code:201
			msg:
			id: 
		
		创建新商品失败：
			code: 202
			msg:
			err:
		重写用户issue失败(id错误):
			code: 203
			msg:
			id:
		重写用户issue失败:
			code:204
			msg:
			err:
*/
