// components/details/details.js
var App = getApp();
Page({

  /**
   * 页面的初始数据
   */
  data: {
    userInfo:null,
    list:null,
    inputValue:'',
    modalType:0, // 0 不显示，1 评论，2 回复
    commentNum:null,
    replyNum:null,
    productId:null,
    isWant:null,
    interval:null,
  },


  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    //接受上一页传过来的productId
    // console.log(options.productId)
    this.data.productId = options.productId;
    // console.log(this.data.productId);
    wx.cloud.init({
		  traceUser: true,
		})
		this.data.userInfo = wx.getStorageSync('userInfoDetail')
    this.getlist();
    this.wantJudge();
    wx.cloud.callFunction({
      name: 'sM_addviewNum',
      data: {
        productId: this.data.productId,
      }
    }).then(res => {
      // console.log(res)
    }).catch(err => {
      console.log(err)
    })
    wx.hideShareMenu();
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {
    
  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },
  //点击查看图片详情
  showPic(e) {
    wx.previewImage({
      current: e.currentTarget.dataset.url, // 当前显示图片的http链接
      urls: [e.currentTarget.dataset.url] // 需要预览的图片http链接列表
    })
  },
  //显示模态框
  showModal(e) {
    // console.log( e.currentTarget.dataset)
    this.setData({
      modalType:e.currentTarget.dataset.targettype
    })
    this.data.commentNum = e.currentTarget.dataset.commentnum;
    this.data.replyNum = e.currentTarget.dataset.replynum;
  },
  //关闭模态框
  hideModal(e) {
    this.setData({
      modalType: null,
      inputValue:null,
    })
    this.data.commentNum = null;
    this.data.replyNum = null;
  },
  //输入触发事件
  inputChange(e) {
    this.data.inputValue = e.detail.value;
  },
  //点击提交事件（没加任何过滤条件,只有未输入的时候直接退出）
  submit(e) {
    this.data.userInfo = wx.getStorageSync('userInfoDetail')
    var hasSign = this.judgeHasSign()
    if(!hasSign) return
    if(!this.data.inputValue) { this.hideModal(); return;}
    wx.showLoading({
      title: '提交中',
      mask: true
    })

    if(this.data.modalType === 1) {
      //评论
      var iscomment = true;
      var commentData = {
        iscomment:iscomment,
        userInfos:this.data.userInfo,
        productId:this.data.productId,
        msg:this.data.inputValue,
        productName:this.data.list.title,
        replyId:this.data.list.userId
      }
    } else if (this.data.modalType === 2) {
      //回复
      var iscomment = false;
      if(this.data.replyNum !== -1) {
        //不是第一个回复
        var msg = '@' + this.data.list.comment[this.data.commentNum].reply[this.data.replyNum].name+"："+ this.data.inputValue;
        var replyId =  this.data.list.comment[this.data.commentNum].reply[this.data.replyNum].userId;
      }
      else {
        //第一个回复
        var msg = '@' + this.data.list.comment[this.data.commentNum].name+"："+this.data.inputValue;
        var replyId = this.data.list.comment[this.data.commentNum].userId;
      }
      var commentData = {
        iscomment:iscomment,
        userInfos:this.data.userInfo,
        productId:this.data.productId,
        msg:msg,
        replyNum: this.data.commentNum,
        replyId:replyId,
        productName:this.data.list.title,
      }
    }
    console.log(this.data)
    console.log(commentData)
    wx.cloud.callFunction({
      name: 'sM_comment',
      data: commentData
    }).then(res => {
      console.log(res.result)
      if(res.result.errCode!==200) { //报错
        wx.hideLoading();
        wx.showToast({
          title: '错误码：'+ res.result.errCode,
          image:'../../images/info.png',
          duration: 2000
        })
      } else { //正常
        this.hideModal();
        this.getlist();
        wx.hideLoading();
        wx.showToast({
          title: '提交成功',
          icon: 'success',
          duration: 2000
        })
        wx.setStorageSync('refreshMain',true)
        wx.setStorageSync('refreshMine',true)
      }
    }).catch(err => {
      console.log(err)
      wx.hideLoading();
      wx.showToast({
        title: '网络错误请重试',
        image:'../../images/info.png',
        duration: 2000
      })
    })
    
  },
  getlist() {
    const db = wx.cloud.database();
    db.collection('sM_productInfo').doc(this.data.productId).get().then(res => {
      this.setData({
        list: res.data
      })
      // console.log(this.data.list)
    })

  },
  wantChange() {
    var hasSign = this.judgeHasSign()
    if(!hasSign) return
    wx.showLoading({
      title: '操作中',
      mask: true
    })
    if(this.data.isWant) { //取消
      var isWant = false;
    } else { //添加
      var isWant = true;
    }
    // console.log(isWant)
    wx.cloud.callFunction({
      name: 'sM_want',
      data: {
        isWant:isWant,
        productId:this.data.list._id,
        userInfos:this.data.userInfo,
        productName:this.data.list.title,
      }
    }).then(res => {
      // console.log(res.result)
      if(res.result.errCode!== 200) { //报错
        wx.hideLoading();
        wx.showToast({
          title: '错误码：'+ res.result.errCode,        
          image:'../../images/info.png',
          duration: 2000
        })
      } else {  //正常
        this.data.list = null;
        wx.hideLoading();
        this.getlist();
        this.wantJudge();
        wx.showToast({
          title: '操作成功',
          icon: 'success',
          duration: 2000
        })
        wx.setStorageSync('refreshMain',true)
        wx.setStorageSync('refreshMine',true)
      } 
    }).catch(err => {
      console.log(err);
      wx.hideLoading();
      wx.showToast({
        title: '操作失败',
        image:'../../images/info.png',        
        duration: 2000
      })
    })
  },

  wantJudge() {
    var that = this;
    this.data.interval = setInterval(function () {
      if(that.data.list && that.data.userInfo) {
        if(that.data.list.wantUser) {
          var index = that.data.list.wantUser.indexOf(that.data.userInfo._id);
          if(index !== -1) {
            that.setData({
              isWant:true
            })
          } else {
            that.setData({
              isWant:false
            })
          } 
          // console.log(that.data.isWant)
          that.stopInterval();
        } else {
          that.setData({
            isWant: false
          })
          // console.log(that.data.isWant)
          that.stopInterval();
        }
      }
    },10)
  },
  stopInterval() {
    clearInterval(this.data.interval)
  },
  jumpToseller() {
    if(this.data.list.isSall) return
    var url = '../sellerInfo/sellerInfo?sellerId='+this.data.list.userId;
    wx.navigateTo({
      url: url
    })
  },

  //判断是否注册
  judgeHasSign() {
    var userInfo = wx.getStorageSync('userInfoDetail');
    if(!userInfo.isSign) {
      wx.showModal({
        title: '警告',
        content: '您还未注册',
        cancelText: '放弃',
        confirmText: '去注册',
        success: res => {
          if (res.confirm) {
            wx.navigateTo({
              url: '../signin/signin?needrefresh=true'
            })
          }
        }
      })
      return false
    } else {
      return true
    }
  },
  
})

