// components/examine/examine.js
Page({

  /**
   * 页面的初始数据
   */
  data: {
    list:null,
    inputValue:null,
    isShowModal:false,
    submitType:null,
    fromApp:true,
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    if(options.fromapp) {
      options.fromapp = true;
    } else {
      options.fromapp = false;
    }
    this.setData({
      fromApp:options.fromapp
    })
    var examine_id = options.id
    wx.cloud.init({
		  traceUser: true,
		})
		const db = wx.cloud.database();
    db.collection('sM_examine').doc(examine_id).get().then(res => {
      this.setData({
        list: res.data
      })
    })
    wx.hideShareMenu();
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },
  //点击查看图片详情
  showPic(e) {
    wx.previewImage({
      current: e.currentTarget.dataset.url, // 当前显示图片的http链接
      urls: [e.currentTarget.dataset.url] // 需要预览的图片http链接列表
    })
  },
  //显示模态框
  showModal(e) {
    // console.log( e.currentTarget.dataset)
    this.setData({
      isShowModal:true,
      inputValue:null,
      submitType: e.currentTarget.dataset.submittype
    })
  },
  //关闭模态框
  hideModal(e) {
    this.setData({
      isShowModal:false
    })
  },
  //输入触发事件
  inputChange(e) {
    this.data.inputValue = e.detail.value;
  },
  submit(e) {
    // console.log(e.detail.formId)
    //审核结果
    var proj = this.data.list;
    if(this.data.submitType) {
      var data = {
        stats:2,
        userInfos: proj.userInfo,
        adds: proj.adds,
        title: proj.title,
        details: proj.details,
        tag: proj.tag,
        price: proj.price,
        isfree:proj.isfree,
        photos: proj.photos,
        oldId: proj._id,
        remarks: this.data.inputValue,
        formId:proj.formId,
        needSend: proj.needSend
      }
    } else {
      var data = {
        stats:3,
        userInfos: proj.userInfo,
        oldId:proj._id,
        remarks: this.data.inputValue,
        formId: proj.formId,
        needSend: proj.needSend
      }
    }
    wx.cloud.callFunction({
      name: 'sM_examine',
      data: data
    }).then(res => {
      wx.showToast({
        title: '操作成功',
        icon: 'success',
        duration: 2000
      })
      console.log(res.result)
      wx.setStorageSync('refreshMain',true)
      wx.setStorageSync('refreshMine',true)
      if(!this.data.fromApp) {
        wx.switchTab({
          url: '../mine/mine'
        })
      } else {
        wx.navigateBack({
          delta: 1
        });
      }
    }).catch(err => {
      console.log(err)
    })
  }
})