// components/homePage/homePage.js
var App = getApp();
Page({

  /**
   * 页面的初始数据
   */
  data: {
    hasData:true,
    classify:1, //1-> 有偿  0-> 免费
    cardCur: 0,
    swiperList: null,
    timeSort:2, //0->未选中  1->正序  2 ->倒序
    priceSort:0,
    viewSort:0,
    list:[],
    skip:0,
    goTopStatus:false,
    showNoMore:false,
  },

  //监听页面高度(上滑或者下滑)
  onPageScroll: function(obj) {
    if (obj.scrollTop > 363) {
        this.setData({
            goTopStatus: true
        })
    } else {
      this.setData({
        goTopStatus: false
      })
    }
  },
  goToTop: function() {
    wx.pageScrollTo({
        scrollTop: 0,
    })
    this.setData({
        goTopStatus: false
    })
  },
  
  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function(options) {
    this.setData({
      swiperList:wx.getStorageSync('swiperList')
    })
    this.getAllProduct();
    wx.hideShareMenu();
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function() {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function() {
    wx.setTabBarStyle({
      color: '#666666',
      selectedColor: '#f43f3b',
      backgroundColor: '#ffffff',
      borderStyle: 'black'
    })
    var refreshMain = wx.getStorageSync('refreshMain')
    if(refreshMain) {
      wx.setStorageSync('refreshMain',false);
      this.setData({classify:1,timeSort:2,priceSort:0,viewSort:0});
      this.data.skip = 0;
      this.getAllProduct();
    }
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function() {
    this.setData({classify:1,timeSort:2,priceSort:0,viewSort:0});
    this.data.skip = 0;
    this.getAllProduct();
  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function() {
    if(this.data.classify) var arr = wx.getStorageSync("productList")
    else var arr = wx.getStorageSync("freeProductList")
    this.paging(arr)
  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function() {

  },
  // cardSwiper
  cardSwiper(e) {
    this.setData({
      cardCur: e.detail.current
    })
  },

  //修改导航
  changeClassify(event) {
    if(!this.data.hasData) {
      this.stopProcess();
      return;
    }
    wx.showLoading({
      title: '加载中',
    })
    this.data.skip =0;
    if(event.currentTarget.dataset.classify == 'paid') {
      this.setData({classify:1,timeSort:2,priceSort:0,viewSort:0});
      var arr = wx.getStorageSync("productList")
      this.sortProduct(arr,2)
    } else {
      this.setData({classify:0,timeSort:2,priceSort:0,viewSort:0});
      var arr = wx.getStorageSync("freeProductList")
      this.sortProduct(arr,2)
    }
  },

  //修改排序
  changeSort(event){
    if(!this.data.hasData) {
      this.stopProcess();
      return;
    }
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    //判断是哪个表
    if(this.data.classify) var arr = wx.getStorageSync("productList")
    else var arr = wx.getStorageSync("freeProductList")
    this.data.skip = 0;
    if(event.currentTarget.dataset.sorttype == 'time') { //点击时间
      if(this.data.timeSort === 0) {                     //时间未被点过
        this.setData({timeSort:2,priceSort:0,viewSort:0});
        this.sortProduct(arr,2)
      }
      else if(this.data.timeSort === 1) {
        this.setData({timeSort:2}) //切换状态
        this.sortProduct(arr,2)
      } 
      else if(this.data.timeSort === 2) {
        this.setData({timeSort:1}) //切换状态
        this.sortProduct(arr,1)
      } 
    } else if(event.currentTarget.dataset.sorttype == 'price') {
      if(this.data.priceSort === 0) {
        this.setData({timeSort:0,priceSort:2,viewSort:0});
        this.sortProduct(arr,6)
      }
      else if(this.data.priceSort === 1) {
        this.setData({priceSort:2})
        this.sortProduct(arr,6)
      }
      else if(this.data.priceSort === 2) {
        this.setData({priceSort:1})
        this.sortProduct(arr,5)
      }
    } else if(event.currentTarget.dataset.sorttype == 'view') {
      if(this.data.viewSort === 0) {
        this.setData({timeSort:0,priceSort:0,viewSort:2});
        this.sortProduct(arr,4)
      }
      else if(this.data.viewSort === 1) {
        this.setData({viewSort:2})
        this.sortProduct(arr,4)
      }
      else if(this.data.viewSort === 2) {
        this.setData({viewSort:1})
        this.sortProduct(arr,3)
      }
    }
  },

  //点击商品跳转详情
  jumpToDetail(event) {
    // console.log(event.currentTarget.dataset.productid)
    var url = '../details/details?productId='+event.currentTarget.dataset.productid;
    wx.navigateTo({
      url: url
    })
  },
  
  //获取商品信息
  getAllProduct() {
    this.data.hasData = true;
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    wx.cloud.callFunction({
      name: 'sM_searchProductList',
      data: {
        status: 701,
      }
      }).then(res => {
        if(!res.result.data) this.noDataProcess();
        else this.processPro(res.result.data);
      }).catch(err => {
        console.log(err)
    })
  },

  //处理获取到的商品信息
  processPro(arr) {
    //数组化，确定顺序，方便分页
    //为了防止全是已删除的然后“无数据”处理失效，加入判断
    var hasData = false
    var productList = []
    for(var i in arr) {
      productList.push(arr[i])
      if(!arr[i].isSall) hasData = true;
    }
    if(hasData) {
      this.sortProduct(productList)
      this.separate(productList)
    } else {
      this.noDataProcess();
    }
    wx.setStorageSync('productList', productList)
  },

  //排序
  sortProduct(arr,type=2) {
    switch(type) {
      case 1: //时间正序
        arr.sort(this.compare('sorttime'));
        break;
      case 2: //时间倒序
        arr.sort(this.compare('sorttime',2));
        break;
      case 3: //浏览量正序
        arr.sort(this.compare('viewNum'));
        break;
      case 4: //浏览量倒序
        arr.sort(this.compare('viewNum',2));
        break;
      case 5: //价格正序
        arr.sort(this.compare('price'));
        break;
      case 6: //价格倒序
        arr.sort(this.compare('price',2));
        break;
    }
    this.paging(arr)
  },

  //排序辅助轮
  compare(property,type=1) { //type不填或者1都是正序，否则逆序
    if(type == 1) {
      return function (a, b) {
        return (a[property] - b[property])
      }
    } else {
      return function (a, b) {
        return (b[property] - a[property])
      }
    }
  },

  //分离各种属性
  separate(arr) {
    var freeList = []
    var bookList = []
    var electronList = []
    var sportList = []
    var axeList = []
    var lifeList = []
    for(var i in arr) {
      if(arr[i].isfree) freeList.push(arr[i])
      switch (arr[i].tag) {
        case "图书":
          bookList.push(arr[i])
          break;
        case "电子":
          electronList.push(arr[i])
          break;
        case "体育":
          sportList.push(arr[i])
          break;
        case "乐器":
          axeList.push(arr[i])
          break;
        case "生活":
          lifeList.push(arr[i])
          break;
        default:
          break;
      }
    }
    wx.setStorageSync('bookList',bookList)
    wx.setStorageSync('electronList',electronList)
    wx.setStorageSync('sportList',sportList)
    wx.setStorageSync('axeList',axeList)
    wx.setStorageSync('lifeList',lifeList)
    wx.setStorageSync('freeProductList', freeList)
  },



  //刷新视觉层，为了节约用户流量，分页
  paging(arr) {
    var batchTimes = Math.ceil(arr.length / 20)
    if(this.data.skip == 0) var newList = [];
    else var newList = this.data.list;
    newList = newList.concat(arr.slice(20*this.data.skip,20*(this.data.skip+1)))
    this.data.skip += 1;
    if(this.data.skip >= batchTimes) {
      // console.log('已经没有更多了')
      this.setData({
        showNoMore:true
      })
    }
    this.data.list = newList;
    this.setData({
      list: this.data.list
    })
    wx.hideLoading()
    wx.stopPullDownRefresh()
  },

  goToTagSearch(event) {
    if(!this.data.hasData) {
      this.stopProcess();
      return;
    }
    var url = '../tagSearch/tagSearch?tagtype='+event.currentTarget.dataset.tagtype;
    wx.navigateTo({
      url: url
    })
  },

  jumpToFuzzy() {
    if(!this.data.hasData) {
      this.stopProcess();
      return;
    }
    wx.navigateTo({
      url: '../fuzzySearch/fuzzySearch'
    })
  },

  //无数据的处理
  noDataProcess() {
    this.data.hasData = false;
    this.setData({
      list:null,
      showNoMore:false,
      classify:1,
      timeSort:2,
      priceSort:0,
      viewSort:0
    })
    if(!this.data.hasData) {
      this.stopProcess();
      return;
    }
  },

  //显示无信息并阻止操作
  stopProcess() {
    wx.hideLoading()
    wx.stopPullDownRefresh()
    wx.showToast({
      title: '空空如也呢',
      image:'../../images/info.png',
      duration: 2000
    })
  },
})