// components/mine/mine.js
Date.prototype.__defineGetter__('ago',function () {
	var diff = (((new Date()).getTime() - this.getTime()) / 1000);
	var day_diff = Math.floor(diff / 86400);
	return day_diff == 0 && (
		diff < 60 && '刚刚' ||
		diff < 120 && '1分钟之前' || 
		diff < 3600 && Math.floor(diff / 60) + '分钟之前' ||
		diff < 7200 && '1小时之前' ||
		diff < 86400 && Math.floor(diff / 3600) + '小时之前' ) ||
		day_diff == 1 && '昨天' ||
		day_diff < 7 && day_diff + '天之前' ||
		Math.ceil( day_diff / 7 ) + '周之前';
})
Page({

  /**
   * 页面的初始数据
   */
  data: {
    userInfoDetail:[],
    unreadMsg:[],
    othersMsg:[],
    issueCount:0,
    wantCount:0,
    msgCount:0,
    examineCount:0,
    isAdmin:false,
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    wx.cloud.init({
		  traceUser: true,
    })
    this.login();
    wx.hideShareMenu();
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    // 4fba48
    wx.setTabBarStyle({
      color: '#666666',
      selectedColor: '#4fba48',
      backgroundColor: '#ffffff',
      borderStyle: 'black'
    })
    var refreshMine = wx.getStorageSync('refreshMine')
    if(refreshMine) {
      wx.setStorageSync('refreshMine',false);
      this.login();
    }
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },

  login() {
    wx.showLoading({
      title: '数据加载中',
      mask: true
    })
    var that = this;
    var userInfoDetail = wx.getStorageSync('userInfoDetail')
    const db = wx.cloud.database()
    db.collection('sM_userInfo').where({
      _id:userInfoDetail._id
    }).get().then(res => {
      var userInfo = res.data[0];
      wx.setStorageSync('userInfoDetail', userInfo)
      wx.setStorageSync('isSign', userInfo.isSign)      
      if(userInfo.isAdmin) {
        this.getExamineCount();
      } else {
        this.processMsg();
      }
		}).catch(err => {
      console.log(err)
      wx.hideLoading({});
      wx.showModal({
        title: '警告',
        content: '网络不佳，登陆失败',
        confirmText: '重试',
        success (res) {
          if (res.confirm) {
            that.login();
            console.log('用户点击确定')
          } else if (res.cancel) {
            console.log('用户点击取消')
          }
        }
      })
    })
  },

  //处理未读消息
  processMsg() {
    var userInfoDetail = wx.getStorageSync('userInfoDetail')
    for(var i in userInfoDetail.unreadMsg) {
      userInfoDetail.unreadMsg[i].ago = this.dateProcess(userInfoDetail.unreadMsg[i])
    }
    this.setData({
      userInfoDetail:userInfoDetail
    })
    wx.setStorageSync('userInfoDetail',userInfoDetail)
    this.attached();
  },
	
	//时间处理辅助轮
	dateProcess(item) {
		var time = new Date(item.time);
		time = time.ago;
		return time;
	},

  //渲染数据
  attached() {
    let that = this;
    let i = 0;
    var issueLength = that.data.userInfoDetail.issue.length
    var wantLength = that.data.userInfoDetail.want.length
    var msgLength = that.data.userInfoDetail.unreadMsg.length
    var examineLength = that.data.examineCount
    numDH();
    function numDH() {
      if (i < 20) {
        setTimeout(function () {
          let a, b, c, d;
          if(i<=issueLength)  a = i; else  a = issueLength;
          if(i<=wantLength)  b = i; else  b = wantLength;
          if(i<=msgLength) c = i; else  c = msgLength;
          if(i<=examineLength) d = i; else  d = examineLength;
          that.setData({
            issueCount: a,
            wantCount: b,
            msgCount: c,
            examineCount: d,
          })
          i++
          numDH();
        }, 30)
      } else {
        that.setData({
          issueCount: issueLength,
          wantCount: wantLength,
          msgCount: msgLength,
          examineCount:examineLength,
        })
      }
    }
    wx.hideLoading()
  },
  showQrcode() {
    wx.previewImage({
      urls: ['cloud://cloud-83621f.636c-cloud-83621f/cherryStore/money.png'],
      current: 'cloud://cloud-83621f.636c-cloud-83621f/cherryStore/money.png' // 当前显示图片的http链接      
    })
  },

  jumpToinform(e) {
    var pagetype = e.target.dataset.pagetype
    if(pagetype == 1) {
      if(this.data.issueCount == 0) {
        wx.showToast({
          title: '空空如也呢',
          image:'../../images/info.png',
          duration: 2000
        })
        return
      }
    } 
    else if (pagetype == 2) {
      if(this.data.wantCount == 0) {
        wx.showToast({
          title: '空空如也呢',
          image:'../../images/info.png',
          duration: 2000
        })
        return
      }
    }
    else if(pagetype ==3) {
      if(this.data.msgCount == 0)  {
        wx.showToast({
          title: '空空如也呢',
          image:'../../images/info.png',
          duration: 2000
        })
        return
      }
    }
    else if(pagetype ==4) {
      if(this.data.examineCount == 0) {
        wx.showToast({
          title: '空空如也呢',
          image:'../../images/info.png',
          duration: 2000
        })
        return
      }
    }
    
    wx.navigateTo({
      url: '../inform/inform?pagetype='+pagetype
    })
  },

  getExamineCount() {
    const db = wx.cloud.database();
    db.collection('sM_examine').count().then(res => {
      // console.log(res)
      this.data.examineCount = res.total;
      this.setData({
        isAdmin:true,
      })
      this.processMsg();
    })
  }
})