// components/signin/signin.js
Page({

  /**
   * 页面的初始数据
   */
  data: {
    userInfoDetail:null,
    userNameErr:'',
    phoneErr:'',
    wxidErr:'',
    needRefresh:false,
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    if(options.needrefresh) this.data.needRefresh = true;
    wx.cloud.init({
      traceUser:true,
    })
    this.setData({
      userInfoDetail:wx.getStorageSync('userInfoDetail')
    })
    console.log(this.data.userInfoDetail)
    wx.hideShareMenu();
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },

  input(e) {
    // console.log(e.detail.value)
    switch(e.target.dataset.inputtype){
      case 1: //userName
        if(e.detail.value) this.data.userInfoDetail.userName = e.detail.value;
        else this.data.userInfoDetail.userName = null;
        break;
      case 2: //phone
        if(e.detail.value) this.data.userInfoDetail.phone = e.detail.value;
        else this.data.userInfoDetail.phone = null;
        break;
      case 3: //wxid
        if(e.detail.value) this.data.userInfoDetail.wxid = e.detail.value;
        else this.data.userInfoDetail.wxid = null;
        break;
    }
  },

  judge() {
    var info = this.data.userInfoDetail
    //用户名
    if(info.userName) {
      if(info.userName.length>10) {
        
        this.setData({
          userNameErr:'用户名过长'
        })
      }
      else {
        this.setData({
          userNameErr:''
        })
      }
    }
    else {
      this.setData({
        userNameErr:'请输入用户名'
      })
    }
    //手机号
    if(info.phone) {
      if(!(/^1[34578]\d{9}$/.test(info.phone))) {
        this.setData({
          phoneErr:'请输入正确的手机号码'
        }) 
      }
      else {
        this.setData({
          phoneErr:''
        })
      }
    } else {
      this.setData({
        phoneErr:'请输入手机号码'
      })
    }
    //微信号
    if(info.wxid) {
      if(info.wxid.length<6) {
        this.setData({
          wxidErr:'请输入正确的微信号码'
        })
      } 
      else {
        this.setData({
          wxidErr:''
        })
      }
    } else {
      this.setData({
        wxidErr:'请输入微信号码'
      })
    }
    if(!this.data.userNameErr&&!this.data.phoneErr&&!this.data.wxidErr){
      return true;
    } else return false;
  },

  submit() {
    var that = this;
    var judge = this.judge();
    if(!judge) return;
    wx.showLoading({
      title:'上传中',
      mask: true
    })
    var userInfo = wx.getStorageSync('userInfo');
    var data = this.data.userInfoDetail;
    data.avatarUrl = userInfo.avatarUrl;
    data.isSign = true;
    var userId = data._id;
    delete data._id;
    delete data._openid;
    const db = wx.cloud.database();
    db.collection('sM_userInfo').doc(userId).set({
      data:data
    }).then(res => {
      if(res.stats.updated==1) {
        //成功
        if(that.data.needRefresh) {
          that.refreshNow();
          return
        }
        wx.hideLoading();
        wx.showToast({
          title: '成功',
          icon: 'success',
          duration: 2000
        })
        wx.setStorageSync('refreshMine',true)
      } else {
        that.dealErr();
      }
    }).catch(err=> {
        that.dealErr();
    })
  },

  //出错处理
  dealErr() {
    wx.hideLoading();
    var that = this;
    wx.showModal({
      title: '警告',
      content: '网络不佳，设置失败',
      confirmText: '重试',
      success (res) {
        if (res.confirm) {
          that.submit();
          console.log('用户点击确定')
        } else if (res.cancel) {
          console.log('用户点击取消')
        }
      }
    })
  },

  //给上传东西的立即刷新
  refreshNow() {
    wx.hideLoading({});
    wx.showLoading({
      title: '数据刷新中',
      mask: true
    })
    var that = this;
    var userInfoDetail = wx.getStorageSync('userInfoDetail')
    const db = wx.cloud.database()
    db.collection('sM_userInfo').where({
      _id:userInfoDetail._id
    }).get().then(res => {
      var userInfo = res.data[0];
      wx.setStorageSync('userInfoDetail', userInfo)
      wx.setStorageSync('isSign', userInfo.isSign)
      wx.hideLoading({});
      wx.showToast({
        title: '成功',
        icon: 'success',
        duration: 2000
      })
		}).catch(err => {
      console.log(err)
      wx.hideLoading({});
      wx.showModal({
        title: '警告',
        content: '网络不佳，刷新失败',
        confirmText: '重试',
        success (res) {
          if (res.confirm) {
            that.refreshNow();
            console.log('用户点击确定')
          } else if (res.cancel) {
            console.log('用户点击取消')
          }
        }
      })
    })
  },
})