// components/tagSearch/tagSearch.js
var App = getApp();
Page({

  /**
   * 页面的初始数据
   */
  data: {
    pageTitle: '标签检索',
    timeSort:2, //0->未选中  1->正序  2 ->倒序
    priceSort:0,
    viewSort:0,
    list:[],
    skip:0,
    goTopStatus:false,
    showNoMore:false,
    rowList:null,
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    this.setData({
      pageTitle: options.tagtype + "类检索"
    })
    switch (options.tagtype) {
      case "图书":
        var arr = wx.getStorageSync("bookList")
        break;
      case "电子":
        var arr = wx.getStorageSync("electronList")
        break;
      case "体育":
        var arr = wx.getStorageSync("sportList")
        break;
      case "乐器":
        var arr = wx.getStorageSync("axeList")
        break;
      case "生活":
        var arr = wx.getStorageSync("lifeList")
        break;
      default:
        break;
    }
    this.data.rowList = arr;
    this.sortProduct(arr)
    wx.hideShareMenu();
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },

  //监听页面高度(上滑或者下滑)
  onPageScroll: function(obj) {
    if (obj.scrollTop > 363) {
        this.setData({
            goTopStatus: true
        })
    } else {
      this.setData({
        goTopStatus: false
      })
    }
  },
  goToTop: function() {
    wx.pageScrollTo({
        scrollTop: 0,
    })
    this.setData({
        goTopStatus: false
    })
  },

  //修改排序
  changeSort(event){
    wx.showLoading({
      title: '加载中',
      mask: true
    })
    var arr = this.data.rowList;
    this.data.skip = 0;
    if(event.currentTarget.dataset.sorttype == 'time') { //点击时间
      if(this.data.timeSort === 0) {                     //时间未被点过
        this.setData({timeSort:2,priceSort:0,viewSort:0});
        this.sortProduct(arr,2)
      }
      else if(this.data.timeSort === 1) {
        this.setData({timeSort:2}) //切换状态
        this.sortProduct(arr,2)
      } 
      else if(this.data.timeSort === 2) {
        this.setData({timeSort:1}) //切换状态
        this.sortProduct(arr,1)
      } 
    } else if(event.currentTarget.dataset.sorttype == 'price') {
      if(this.data.priceSort === 0) {
        this.setData({timeSort:0,priceSort:2,viewSort:0});
        this.sortProduct(arr,6)
      }
      else if(this.data.priceSort === 1) {
        this.setData({priceSort:2})
        this.sortProduct(arr,6)
      }
      else if(this.data.priceSort === 2) {
        this.setData({priceSort:1})
        this.sortProduct(arr,5)
      }
    } else if(event.currentTarget.dataset.sorttype == 'view') {
      if(this.data.viewSort === 0) {
        this.setData({timeSort:0,priceSort:0,viewSort:2});
        this.sortProduct(arr,4)
      }
      else if(this.data.viewSort === 1) {
        this.setData({viewSort:2})
        this.sortProduct(arr,4)
      }
      else if(this.data.viewSort === 2) {
        this.setData({viewSort:1})
        this.sortProduct(arr,3)
      }
    }
  },

  //排序
  sortProduct(arr,type=2) {
    switch(type) {
      case 1: //时间正序
        arr.sort(this.compare('sorttime'));
        break;
      case 2: //时间倒序
        arr.sort(this.compare('sorttime',2));
        break;
      case 3: //浏览量正序
        arr.sort(this.compare('viewNum'));
        break;
      case 4: //浏览量倒序
        arr.sort(this.compare('viewNum',2));
        break;
      case 5: //价格正序
        arr.sort(this.compare('price'));
        break;
      case 6: //价格倒序
        arr.sort(this.compare('price',2));
        break;
    }
    this.paging(arr)
  },

  //排序辅助轮
  compare(property,type=1) { //type不填或者1都是正序，否则逆序
    if(type == 1) {
      return function (a, b) {
        return (a[property] - b[property])
      }
    } else {
      return function (a, b) {
        return (b[property] - a[property])
      }
    }
  },

  //刷新视觉层，为了节约用户流量，分页
  paging(arr) {
    var batchTimes = Math.ceil(arr.length / 20)
    if(this.data.skip == 0) var newList = [];
    else var newList = this.data.list;
    newList = newList.concat(arr.slice(20*this.data.skip,20*(this.data.skip+1)))
    this.data.skip += 1;
    if(this.data.skip >= batchTimes) {
      console.log('已经没有更多了')
      this.setData({
        showNoMore:true
      })
    }
    this.data.list = newList;
    this.setData({
      list: this.data.list
    })
    wx.hideLoading()
    wx.stopPullDownRefresh()
  },

  //点击商品跳转详情
  jumpToDetail(event) {
    // console.log(event.currentTarget.dataset.productid)
    var url = '../details/details?productId='+event.currentTarget.dataset.productid;
    wx.navigateTo({
      url: url
    })
  },
})